# Visualization
TKV3d
Select3D

# Select3D_SensitiveBox Class Reference

A framework to define selection by a sensitive box.
.

`#include <Select3D_SensitiveBox.hxx>`

Inheritance diagram for Select3D_SensitiveBox:

[legend]

## Public Member Functions

Standard_EXPORT | Select3D_SensitiveBox (const Handle(SelectBasics_EntityOwner)&OwnerId, const Bnd_Box &BoundingBox)
| Constructs a sensitive box object defined by the owner OwnerId, and the bounding box BoundingBox. .
Standard_EXPORT | Select3D_SensitiveBox (const Handle(SelectBasics_EntityOwner)&OwnerId, const Standard_Real XMin, const Standard_Real YMin, const Standard_Real ZMin, const Standard_Real XMax, const Standard_Real YMax, const Standard_Real ZMax)
| Constructs a sensitive box object defined by the owner OwnerId, and the coordinates Xmin, YMin, ZMin, XMax, YMax, ZMax. Xmin, YMin and ZMin define the minimum point in the front lower left hand corner of the box, and XMax, YMax and ZMax define the maximum point in the back upper right hand corner of the box. .
Standard_EXPORT void | Project (const Select3D_Projector &aProjector)
| projection of the sensitive primitive in order to get 2D boxes for the Sort Algorithm
Standard_EXPORT void | Areas (SelectBasics_ListOfBox2d &boxes)
| gives the 2D boxes which represent the Box in the selection process...
Standard_EXPORT Handle_Select3D_SensitiveEntity | GetConnected (const TopLoc_Location &aLocation)
| Returns the sensitive entity found at the location aLocation. You must redefine this function for any type of sensitive entity which can accept another connected sensitive entity.//can be connected to another sensitive entity. .
Standard_EXPORT Standard_Boolean | Matches (const Standard_Real X, const Standard_Real Y, const Standard_Real aTol, Standard_Real &DMin)
Standard_EXPORT Standard_Boolean | Matches (const Standard_Real XMin, const Standard_Real YMin, const Standard_Real XMax, const Standard_Real YMax, const Standard_Real aTol)

Matches the box defined by the coordinates Xmin,
Ymin, Xmax, Ymax with the entity found at that point
within the tolerance aTol.
Xmin, YMin define the minimum point in the lower left
hand corner of the box, and XMax, YMax define the
maximum point in the upper right hand corner of the box.
You must redefine this function for every inheriting entity.
You will have to call this framework inside the redefined function.
.

virtual Standard_EXPORT Standard_Boolean | Matches (const TColgp_Array1OfPnt2d &Polyline, const Bnd_Box2d &aBox, const Standard_Real aTol)
| prevents from hiding virtual methods...
Standard_EXPORT Standard_Real | ComputeDepth (const gp_Lin &EyeLine) const
| Returns the depth of this object on the line EyeLine. EyeLine goes through the eye towards a point defined by the coordinates X,Y in the function GetEyeLine. //! gives an abcissa on <alin> . <alin> represents the line going through the eye towards an X,Y point on the screen. This Method must return a mean Depth on this line. .
virtual Standard_EXPORT void | Dump (Standard_OStream &S, const Standard_Boolean FullDump=Standard_True) const
| 2 options : <fulldump> = False -> general information <fulldump> = True -> whole informtion 3D +2d ...
const Bnd_Box & | Box () const
| Returns the sensitive 3D box used at the time of construction. .
Standard_EXPORT const | Handle (Standard_Type)&DynamicType() const

## Private Member Functions

Standard_EXPORT void | ProjectBox (const Select3D_Projector &aPrj, const Bnd_Box &aBox)

## Private Attributes

Bnd_Box | mybox3d
Bnd_Box2d | mybox2d

## Constructor & Destructor Documentation

Standard_EXPORT Select3D_SensitiveBox::Select3D_SensitiveBox | ( | const Handle(SelectBasics_EntityOwner)& | OwnerId,
|  | const Bnd_Box & | BoundingBox
| ) |

Standard_EXPORT Select3D_SensitiveBox::Select3D_SensitiveBox | ( | const Handle(SelectBasics_EntityOwner)& | OwnerId,
|  | const Standard_Real | XMin,
|  | const Standard_Real | YMin,
|  | const Standard_Real | ZMin,
|  | const Standard_Real | XMax,
|  | const Standard_Real | YMax,
|  | const Standard_Real | ZMax
| ) |

## Member Function Documentation

Standard_EXPORT void Select3D_SensitiveBox::Areas | ( | SelectBasics_ListOfBox2d & | boxes | ) | `[virtual]`

| Implements SelectBasics_SensitiveEntity.

const Bnd_Box & Select3D_SensitiveBox::Box | ( |  | ) | const`[inline]`

Standard_EXPORT Standard_Real Select3D_SensitiveBox::ComputeDepth | ( | const gp_Lin & | EyeLine | ) | const`[virtual]`

| Implements Select3D_SensitiveEntity.

virtual Standard_EXPORT void Select3D_SensitiveBox::Dump | ( | Standard_OStream & | S,
|  | const Standard_Boolean | FullDump = `Standard_True`
| ) | const`[virtual]`

| Reimplemented from Select3D_SensitiveEntity.

Standard_EXPORT Handle_Select3D_SensitiveEntity Select3D_SensitiveBox::GetConnected | ( | const TopLoc_Location & | aLocation | ) | `[virtual]`

| Reimplemented from Select3D_SensitiveEntity.

Standard_EXPORT const Select3D_SensitiveBox::Handle | ( | Standard_Type |  | ) | const

| Reimplemented from Select3D_SensitiveEntity.

virtual Standard_EXPORT Standard_Boolean Select3D_SensitiveBox::Matches | ( | const TColgp_Array1OfPnt2d & | Polyline,
|  | const Bnd_Box2d & | aBox,
|  | const Standard_Real | aTol
| ) | `[virtual]`

| Reimplemented from Select3D_SensitiveEntity.

Standard_EXPORT Standard_Boolean Select3D_SensitiveBox::Matches | ( | const Standard_Real | XMin,
|  | const Standard_Real | YMin,
|  | const Standard_Real | XMax,
|  | const Standard_Real | YMax,
|  | const Standard_Real | aTol
| ) | `[virtual]`

| Reimplemented from Select3D_SensitiveEntity.

Standard_EXPORT Standard_Boolean Select3D_SensitiveBox::Matches | ( | const Standard_Real | X,
|  | const Standard_Real | Y,
|  | const Standard_Real | aTol,
|  | Standard_Real & | DMin
| ) | `[virtual]`

| Reimplemented from Select3D_SensitiveEntity.

Standard_EXPORT void Select3D_SensitiveBox::Project | ( | const Select3D_Projector & | aProjector | ) | `[virtual]`

| Reimplemented from Select3D_SensitiveEntity.

Standard_EXPORT void Select3D_SensitiveBox::ProjectBox | ( | const Select3D_Projector & | aPrj,
|  | const Bnd_Box & | aBox
| ) | `[private]`

## Field Documentation

Bnd_Box2d Select3D_SensitiveBox::mybox2d `[private]`

Bnd_Box Select3D_SensitiveBox::mybox3d `[private]`

The documentation for this class was generated from the following files:

- Select3D_SensitiveBox.hxx
- Select3D_SensitiveBox.lxx